# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-List-MoreUtils
Version:	0.430
Release:	1.%{__distinit}%{__distvers}
Summary:	Provide the stuff missing in List::Util
License:	(GPL+ or Artistic) and ASL 2.0
URL:		https://metacpan.org/release/List-MoreUtils
Source0:	https://cpan.metacpan.org/modules/by-module/List/List-MoreUtils-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(base)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(lib)
BuildRequires:	perl(PerlIO)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Text::ParseWords)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter::Tiny) >= 0.038
BuildRequires:	perl(List::MoreUtils::XS) >= 0.430
BuildRequires:	perl(parent)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Exporter)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Math::Trig)
BuildRequires:	perl(overload)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::Builder::Module)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Tie::Array)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(List::MoreUtils::XS) >= 0.430

%description
List::MoreUtils provides some trivial but commonly needed functionality
on lists that is not going to go into List::Util.

%prep
%setup -q -n List-MoreUtils-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%if 0%{?_licensedir:1}
%license ARTISTIC-1.0 GPL-1 LICENSE
%else
%doc ARTISTIC-1.0 GPL-1 LICENSE
%endif
%doc Changes README.md
%{perl_vendorlib}/List/
%{_mandir}/man3/List::MoreUtils.3*
%{_mandir}/man3/List::MoreUtils::Contributing.3*
%{_mandir}/man3/List::MoreUtils::PP.3*

%changelog
* Wed Oct 21 2020 Paul Howarth <paul@city-fan.org> - 0.430-1
- Update to 0.430
  - Fix failing installation in parallel make (GH#38)
  - Infrastructure improvements and tooling updates, lots of author tests with
    corresponding fixes added
  - Added slide and slideatatime functions
  - Documentation fixes (GH#21, GH#33, GH#34, CPAN RT#126029, CPAN RT#132043,
    CPAN RT#132940)
  - Bump List::MoreUtils::XS requirement to 0.430

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 0.428-6
- Perl 5.30 rebuild

* Tue Dec 12 2017 Paul Howarth <paul@city-fan.org> - 0.428-1
- Update to 0.428
  - Fix GH#22 (Upgrading from LMU 0.416 to split XS/PP version will fail),
    this time hopefully the right way (CPAN RT#123310)
  - Fix GH#29 (pairwise() PP implementation add tail undefs if array sizes
    differ)

* Fri Oct 13 2017 Paul Howarth <paul@city-fan.org> - 0.426-1
- Update to 0.426
  - Fix broken arrayify prototype
  - Revert removal of old List::MoreUtils::XS parts
  - Re-introduce Config::AutoConf (CPAN RT#122875)
  - Bump required version of List::MoreUtils::XS to 0.426, if XS is available

* Thu Sep  7 2017 Paul Howarth <paul@city-fan.org> - 0.425-1
- Update to 0.425
  - Makefile.PL: modify PREREQ_PM instead of recommend dynamically

* Tue Aug 22 2017 Paul Howarth <paul@city-fan.org> - 0.423-1
- Update to 0.423
  - Sync version with List::MoreUtils::XS
  - Add some new functions: qsort (XS only), binsert, bremove, listcmp,
    arrayify (CPAN RT#17230), samples (CPAN RT#77562), minmaxstr
    (CPAN RT#106401), lower_bound, upper_bound, equal_range, frequencies
    occurrences, mode (CPAN RT#91991), zip6 (CPAN RT#42921), reduce_0,
    reduce_1, reduce_u
  - Add examples for binsert/bremove (LMU::XS GH#1)
  - Improve tests
  - Make List::MoreUtils::XS independent from List::MoreUtils
  - Improve Makefile.PL regarding some build artifacts
  - Update tests to latest List::MoreUtils::XS
  - Recommend List::MoreUtils::XS 0.423
- BR:/R: LMU::XS ≥ 0.423 as there is no longer a bootstrapping issue
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Fri Apr  7 2017 Paul Howarth <paul@city-fan.org> - 0.419-1
- Update to 0.419
  - Makefile.PL failed due to unescaped paths interpolated in regex pattern
    (CPAN RT#120799)

* Thu Mar 30 2017 Paul Howarth <paul@city-fan.org> - 0.418-1
- Update to 0.418
  - Divorce List::MoreUtils and List::MoreUtils::XS
  - Change license to Apache 2.0 to avoid code stealing without credits
  - Don't support Perl 5.6 out of the box any more
  - Fix CPAN RT#120235: uniq examples are incorrect
  - Remove things that will be never done from TODO list (GH#18)
  - Spelling fixes
- Package is now noarch
- Drop bundled Test::More as we always have a recent enough version now

* Wed Jul  6 2016 Paul Howarth <paul@city-fan.org> - 0.416-1
- Update to 0.416
  - Change the way how the XS part is loaded as a result of CPAN RT#115808
  - Fix some spelling errors (CPAN RT#115807)
  - Requires XSLoader 0.22 (not reflected in rpm dependencies)
- Package newly-shipped license files
- Drop now-redundant provides patch

* Tue May 17 2016 Paul Howarth <paul@city-fan.org> - 0.415-2
- BR: perl-generators where available

* Mon May  2 2016 Paul Howarth <paul@city-fan.org> - 0.415-1
- Update to 0.415
  - Fix CPAN RT#75727: After's XS implementation call XSRETURN(-1) when it
    doesn't find an element
  - Fix CPAN RT#113117: XS's minmax() sometimes return undef (perl ≥ 5.20)
  - Explicit test for thesis in CPAN RT#110998: XS implementation of pairwise
    fails with memory allocation error when there are more return values than
    in original lists - thesis is proven wrong
  - Efficiency improvements
  - Improve some tests to get clearer reports
  - Distinguish between "Makefile.PL finds a .git directory" and
    "Makefile.PL runs in maintainer mode"
- Simplify find commands using -delete

* Sat Jun 13 2015 Paul Howarth <paul@city-fan.org> - 0.413-1
- Update to 0.413
  - Fix compiling in c++ mode (deprecated, but some people seem to require it)
    (CPAN RT#104690)

* Wed May 20 2015 Paul Howarth <paul@city-fan.org> - 0.412-1
- Update to 0.412
  - Move generation of test endpoints to author stage as requested per issue/#9
  - Add a rough guide for contributors
  - Fix CPAN RT#103251 to avoid removing bundled stuff by accident
  - Fix compilation errors under cl

* Mon Mar 30 2015 Paul Howarth <paul@city-fan.org> - 0.410-1
- Update to 0.410
  - Fix CPAN RT#102885: uniq bug broke tied array
  - Fix issue/8: Macros introduced in dfd851147f cause problems with MSVC
  - Update ppport.h from 3.25 to 3.31
  - Fix multiple mg_get can break weird ties
  - Fix test run using PERL5OPT=d:Confess
  - Use base instead of parent, 'cause parent isn't bundled before 5.10.1
  - Update bundled bootstrap modules
    - Data::Tumbler to 0.010
    - Test::WriteVariants to 0.012
    - Config::AutoConf to 0.311
  - Fix spelling (and add stop-words for names etc. in author tests)

* Wed Mar 18 2015 Paul Howarth <paul@city-fan.org> - 0.408-1
- Update to 0.408
  - Fix CPAN RT#102840: uniq broken for call-by-function-return
  - Fix CPAN RT#102853: hent_val accesses
  - Fix CPAN RT#102833: Compilation error with perl 5.21.7+
  - Fix regex for CPAN RT#44518 test

* Wed Mar 18 2015 Paul Howarth <paul@city-fan.org> - 0.407-1
- Update to 0.407
  - Added one(), onlyidx(), onlyval() (CPAN RT#73134) and onlyres()
  - Improve XS maintainability
  - Document how uniq/distinct deal with undef (CPAN RT#49800)
  - Add bsearchidx to satisfy CPAN RT#63470
  - Add singleton to satisfy CPAN RT#94382
  - Fix CPAN RT#82039 - uniq changes the type of its arguments
  - Fix CPAN RT#44518 again

* Tue Mar  3 2015 Paul Howarth <paul@city-fan.org> - 0.406-1
- Update to 0.406
  - Add new functions firstres and lastres in addition to firstidx, lastidx,
    firstval and lastval
  - Regenerate MANIFEST to bundle README.md

* Sat Feb 14 2015 Paul Howarth <paul@city-fan.org> - 0.405-1
- Update to 0.405
  - Fix CPAN RT#78527 - first_val/last_val in documentation
  - Fix CPAN RT#102055 - ExtUtils::MakeMaker required version absurdly high
  - Fix compiler issue for older/ansi-c89 compilers
  - Remove local compat workarounds in favour for ppport.h

* Thu Jan 29 2015 Paul Howarth <paul@city-fan.org> - 0.404-1
- Update to 0.404
  - Fix ancient toolchains (PREREQ_PM & Co. set appropriately)
  - Bump version required of Test::More to 0.96 (#toolchain calls it a "sane
    subset")
  - Fix some meta-data #toolchain pointed out

* Tue Jan 27 2015 Paul Howarth <paul@city-fan.org> - 0.403-1
- Update to 0.403
  - Remove most recent stable perl recommendation from meta to work around
    misbehaving CPAN clients blocking update
  - Update copyright date
  - Ensure AUTHOR is a string on older toolchains
- No longer need to bundle ExtUtils::MakeMaker

* Sat Jan  3 2015 Paul Howarth <paul@city-fan.org> - 0.402-1
- Update to 0.402
  - Reformat Changes as per CPAN::Changes::Spec
  - Move repository to GitHub
  - Merge Tassilo's 0.25_nn dev releases back
    - Mark "any" and "all" as "to be discussed"
    - Bump version to clarify new age (contributors welcome!)
    - Bump minimum perl version to 5.8.1
  - Split implementations between existing authors
  - Switch to DynaLoader and Exporter::Tiny
  - Rely for testing on Test::WriteVariants and Data::Tumbler (DBI::Test
    technology to improve tests)
  - Fix 64-bit integer precision (CPAN RT#93207)
  - Fix compile error on threaded perls (CPAN RT#93934)
  - Fix exporter configuration (CPAN RT#93929)
  - Allow choice of implementation (CPAN RT#40905)
  - Add test for CPAN RT#76749
  - Fix issues on older perls back to 5.8.1
  - Fix backward compatibility issues (CPAN RT#93995, CPAN RT#94013)
  - Fix some spelling issues (CPAN RT#86347, CPAN RT#87490)
  - Clarify dependencies, especially recommended ones
  - Add some additional tests to prove reported bugs
  - Rename implementations from alias => relax and tassilo => strict
  - Remove 'sno' implementation
  - Add precedence 'default' in addition to 'all' for those who prefer
    strict over relax
  - Refactor LMU
  - Cut out exporter-related cruft; it was only necessary when needing to
    choose between multiple implementations
  - Reorganize and clarify documentation
  - Revise SYNOPSIS and DESCRIPTION for revised export model
  - Introduce ":like_*" import tags
  - Remove Data::Tumbler and Module::Pluggable from configure dependencies;
    they're coming with Test::WriteVariants
  - Fix none for 0.24 and clarify API tag documentation
  - Refactor import tags for clarity
  - Bundle non-core modules (compared to 5.14)
  - Bundle configure_requires using inc::latest
  - Check types before starting logic (CPAN RT#96596)
  - Lower minimum perl required to 5.6
  - Switch to check_produce_loadable_xs_build of Config::AutoConf 0.307
- This release by REHSACK → update source URL
- Classify buildreqs by usage
- Bundle a recent enough copy of ExtUtils::MakeMaker if we don't have one
- Bundle a recent enough copy of Test::More if we don't have one
- Add hook for bootstrapping without running the test suite
- Require perl ≥ 5.10, as it doesn't seem to be able to use XS on 5.8.8

* Mon Sep  1 2014 Paul Howarth <paul@city-fan.org> - 0.33-14
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Thu Sep 19 2013 Paul Howarth <paul@city-fan.org> - 0.33-11.0
- Don't BR: perl(ExtUtils::CBuilder) when bootstrapping

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> - 0.33-9.0
- Perl 5.18 rebuild

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 0.33-4.0
- Perl 5.16 post-bootstrap rebuild

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.33-3.0
- BR:/R: perl(Carp)
- BR: perl(constant), perl(Exporter) and perl(ExtUtils::CBuilder)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Jan 24 2012 Paul Howarth <paul@city-fan.org> - 0.33-2.0
- Package LICENSE file
- Drop redundant buildreq perl(Test::Pod::Coverage)
- BR: perl(ExtUtils::MakeMaker) and perl(Test::More)
- BR: perl(Test::LeakTrace) where possible
- BR: perl(Pod::Simple) and (Test::CPAN::Meta)
- BR: perl(Test::MinimumVersion) unless we're bootstrapping
- Run the developer tests too

* Thu Aug  4 2011 Paul Howarth <paul@city-fan.org> - 0.33-1.0
- Update to 0.33
  - Updated can_xs to fix a bug in it

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.32-2.0
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri May 20 2011 Paul Howarth <paul@city-fan.org> - 0.32-1
- Update to 0.32
  - update copyright year
  - tweak documentation of all() and none()
  - memory leak fixed for apply() and XS version restored
  - memory leak fixed for indexes() and XS version restored
  - memory leak fixed for part() and XS version restored
  - more accurate detection of XS support
- Nobody else likes macros for commands

* Thu Dec 16 2010 Paul Howarth <paul@city-fan.org> - 0.30-1
- Update to 0.30
  - change the way we localise PERL_DL_NONLAZY to false to remove a warning
    that some people were seeing; the new approach is taken from the way that
    List::Util does it

* Wed Dec  8 2010 Paul Howarth <paul@city-fan.org> - 0.29-1
- Update to 0.29
  - refactored the split test scripts into a common test module to be shared
    between both the Perl and XS versions
  - reapply fix for CPAN RT#39847
    "minmax error: unpredictable results with lists of 1 element"
  - reduced test suite peak memory consumption by 5-10 meg
  - added the 'distinct' alias for the uniq function, for people that like
    their chained map/grep/sort pipelines with a SQL'ish flavour
  - expanded test suite for the any() group of functions
  - the any() group of functions now strictly always return scalar boolean
    true, false and undef to match the XS version
  - general house cleaning
  - the behaviour of any/all/none/notall has changed when passed a null list
    to treat a null list as a legitimate list (CPAN RT#40905)
  - disabled the leaking XS versions of part(), apply() and indexes()
  - restored the regression test for CPAN RT#38630 from 0.23
  - adding uniq warning tests, disabled initially

* Tue Nov 23 2010 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26 (first attempt at repackaging the List::MoreUtils code in
  Makefile.PL and release toolchain similar to Params::Util)
- New upstream maintainer ADAMK -> update source URL

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 0.25-4
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 10 2010 Paul Howarth <paul@city-fan.org> - 0.25-3
- Fix dist tag to work with RHEL6 Beta

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 0.25-2
- Dist tag for Rawhide no longer needs special-casing
- Use %%{?perl_default_filter} for provides filter

* Mon Aug  3 2009 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25_02 (note - CPAN RT#40905 fix is a backwards-incompatible change)
  - handle stack properly when stack grown from inside code-references
  - a couple of tests for each_arrayref were calling each_array
  - fix CPAN RT#40905 (don't return undef when none is passed an empty array)
  - fix CPAN RT#39847 (minmax err: unpredictable results w/ lists of 1 element)
  - fix CPAN RT#37533 (uniq doesn't like undef values)
  - fix CPAN RT#43214 (uniq warns on undef values)
  - fix CPAN RT#44518 (bug in pairwise as $a and $b lexically defined with my)
  - fix CPAN RT#41097 (big memory leak with XS part())
  - fix CPAN RT#41494 (memory leak in indexes() [XS])
  - reduce mem requirement for part() tests to fix many test suite failures
  - new function bsearch(), which performs a binary search
  - fix awkward ok() override in List-MoreUtils.t to improve diagnostics

* Sun Mar  1 2009 Paul Howarth <paul@city-fan.org> - 0.22-8
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Mon Sep  1 2008 Paul Howarth <paul@city-fan.org> - 0.22-7
- Import from Fedora

* Thu Feb 28 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-6
- Rebuild normally, second pass

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-5
- Rebuild for perl 5.10 (again), tests disabled for first pass

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.22-4
- Autorebuild for GCC 4.3

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-3
- Rebuild normally, second pass

* Fri Jan 11 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-2.1
- Rebuild for new perl, first pass, disable TPC and tests

* Sun Sep 10 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-2
- Rebuild for FC6

* Mon Jul  3 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-1
- Update to 0.22

* Mon Jun 19 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.21-1
- Update to 0.21

* Sat Jun 10 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-1
- Update to 0.20

* Sat Apr 22 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.19-1
- First build
